import QtQuick 2.0

Rectangle
{
    property string cardname: "default_text"
    property int card_size_y: 30
    property string card_color: "grey"


    readonly property int pos_player_lib : 0
    readonly property int pos_player_hand : pos_player_lib+1
    readonly property int pos_player_field : pos_player_hand+1
    readonly property int pos_player_grave : pos_player_field+1
    readonly property int pos_player_removed : pos_player_grave+1

    property int position : pos_player_lib

    signal clickedOnCard(int state);


    property int card_id: -1


    width: parent.width
    height: card_size_y
    clip: true

    color: card_color
    Text
    {
        text: cardname
        clip: true
    }

    MouseArea
    {
        acceptedButtons: Qt.LeftButton
        width: card_size_x;

        anchors.fill: parent

        onClicked:
        {
            console.log("Taking card to hand" + card_id);

            if(position==pos_player_lib)
            {
                position = pos_player_hand;
            }

            else if(position==pos_player_grave)
            {
                position = pos_player_hand;
            }
            else if(position==pos_player_removed)
            {
                position = pos_player_hand;
            }


            //position = position == 1 ? 2 : 1;
            parent.clickedOnCard(0); //selection state for indicator if card was clicked on
        }
    }


    MouseArea
    {
        acceptedButtons: Qt.RightButton
        width: card_size_x;
        z:2

        anchors.fill: parent

        onClicked:
        {
            console.log("Taking card to hand" + card_id);

            if(position==pos_player_lib)
            {
                position = pos_player_field;
            }

            else if(position==pos_player_grave)
            {
                position = pos_player_field;
            }
            else if(position==pos_player_removed)
            {
                position = pos_player_field;
            }

            parent.clickedOnCard(0); //selection state for indicator if card was clicked on
        }
    }

    MouseArea
    {
        acceptedButtons: Qt.MiddleButton
        width: card_size_x;
        z:3

        anchors.fill: parent

        onClicked:
        {
            if(position==pos_player_lib)
            {
                position = pos_player_field;
            }

            else if(position==pos_player_grave)
            {
                position = pos_player_removed;
            }
            else if(position==pos_player_removed)
            {
                position = pos_player_grave;
            }

            parent.clickedOnCard(0); //selection state for indicator if card was clicked on
        }
    }

}
