import QtQuick 2.0

Rectangle
{
    width: 200
    height: 60
    id:info_box

    property int life_player: Lifestate.player_life
    property int life_opponent: Lifestate.opponent_life

    function updateLife()
    {
        Lifestate.player_life = life_player;
        Lifestate.opponent_life = life_opponent;
    }

    Row
    {
        Rectangle
        {
            id: life_player_rect
            width: 100
            height: 60
            color: "#43f200"

            Text {
                id: life_player_text
                x: 0
                y: 0
                text: life_player
                font.pixelSize: 12
            }

            MouseArea
            {
                acceptedButtons: Qt.LeftButton | Qt.RightButton

                anchors.fill: parent;
                onClicked:
                {
                    if(mouse.button === Qt.LeftButton)
                    {
                        life_player = life_player-1;
                    }
                    if(mouse.button === Qt.RightButton)
                    {
                        life_player = life_player+1;
                    }
                    updateLife();
                }


            }
        }

        Rectangle {
            id: life_opponent_rect
            width: 100
            height: 60
            color: "#ff2424"

            Text {
                id: life_opponent_text
                x: 0
                y: 0
                text: life_opponent
                font.pixelSize: 12
            }

            MouseArea
            {
                acceptedButtons: Qt.LeftButton | Qt.RightButton

                anchors.fill: parent;
                onClicked:
                {
                    if(mouse.button === Qt.LeftButton)
                    {
                        life_opponent = life_opponent-1;
                    }
                    if(mouse.button === Qt.RightButton)
                    {
                        life_opponent = life_opponent+1;
                    }
                    updateLife();
                }
            }
        }

    }

}
