import QtQuick 2.9
import QtQuick.Window 2.3
import QtQuick.Layouts 1.3
import QtQuick.Controls 2.2

    Rectangle
    {
        function test(url)
        {
            console.log("test("+url+")");
        }

        Layout.minimumWidth: card_size_x
        Layout.minimumHeight: card_size_y

        property int card_size_x: 80
        property int card_size_y: 120
        property string cardname: "Birds of Paradise"
        property string carddescription: "Tap to get a mana of any color"
        property string cardManaCost: "Alpha"
        property string url: "https://img.scryfall.com/cards/large/front/f/e/feefe9f0-24a6-461c-9ef1-86c5a6f33b83.jpg?1562943045"
        property string urlbig: "https://img.scryfall.com/cards/large/front/f/e/feefe9f0-24a6-461c-9ef1-86c5a6f33b83.jpg?1562943045"

        property int card_id: -1
        property int is_selected : 0
        property int position : 0
        property int tapped : 0
        property int card_type: 666

        readonly property int pos_player_lib : 0
        readonly property int pos_player_hand : 1
        readonly property int pos_player_field : 2
        readonly property int pos_player_grave : 3
        readonly property int pos_player_removed : 4
        readonly property int pos_op_lib : 5
        readonly property int pos_op_hand: 6
        readonly property int pos_op_field : 7
        readonly property int pos_op_grave : 8
        readonly property int pos_op_removed: 9



        //signal leftClickOnCard ()
        signal hoveredOnCard (string _url);
        signal selectionChanged(int new_state);
        signal tapChanged(int new_state);
        signal clickedOnCard();


        //rotation: tapped == 0 ? 0 : (position == pos_player_field ? 90 : 0)
        rotation: tapped == 0 ? 0 : 90
        transformOrigin: Item.Center

        width: card_size_x
        height: card_size_y

        Image {
            id: card_image
            width: card_size_x
            height: card_size_y
            z: 1
            source: url
            visible: position == pos_op_field ? true: false;
        }

        Image {
            id: card_background_image
            width: card_size_x
            height: card_size_y
            z: 1
            source: "magiccard.png"
            visible: position == pos_op_hand ? true: false;
        }

        MouseArea {
            acceptedButtons: Qt.LeftButton
            Layout.minimumWidth: card_size_x;

            z: 3
            anchors.fill: parent
            hoverEnabled: true

            onClicked:
            {
                //console.log("Destroying card" + card_id);

                if(position==pos_op_field && !(mouse.modifiers & Qt.ShiftModifier))
                {
                    tapped = 1-tapped;
                    parent.tapChanged(tapped);
                }

                else if(position==pos_op_field && (mouse.modifiers & Qt.ShiftModifier))
                {
                    position = pos_op_hand;
                }

                else if(position == pos_op_hand)
                {
                    position = pos_op_field;
                }
                parent.clickedOnCard();
            }

            onHoveredChanged:
            {
                parent.hoveredOnCard(urlbig);
            }
        }

        MouseArea {
            acceptedButtons: Qt.RightButton
            Layout.minimumWidth: card_size_x;

            z: 4
            anchors.fill: parent

            onClicked:
            {
                if(position==pos_op_hand)
                {
                    position = pos_op_grave;
                }

                else if(position==pos_op_field)
                {
                    position = pos_op_grave;
                }
                parent.clickedOnCard();
            }
        }


        MouseArea {
            acceptedButtons: Qt.MiddleButton
            Layout.minimumWidth: card_size_x;

            z: 5
            anchors.fill: parent

            onClicked:
            {
                if(position==pos_op_field)
                {
                    position = pos_op_lib;
                }

                else if(position==pos_op_hand)
                {
                    position = pos_op_lib;
                }

                parent.clickedOnCard();
            }
        }

        Component.onCompleted:
        {
            // This is available in all editors.
            //hoveredOnCard.connect(test);
            //console.log(name+", pos: "+position);
        }
    }
