import QtQuick 2.0

Rectangle
{
    property int card_size_y: 30
    property string card_color: "grey"

    readonly property int pos_player_lib : 0
    readonly property int pos_player_hand : 1
    readonly property int pos_player_field : 2
    readonly property int pos_player_grave : 3
    readonly property int pos_player_removed : 4
    readonly property int pos_op_lib : 5
    readonly property int pos_op_hand: 6
    readonly property int pos_op_field : 7
    readonly property int pos_op_grave : 8
    readonly property int pos_op_removed: 9

    property int position : pos_op_lib


    property int card_id: -1
    property string cardname: "default_text"
    property string carddescription: "Tap to get a mana of any color"
    property string cardManaCost: "Alpha"
    property string url: "https://img.scryfall.com/cards/large/front/f/e/feefe9f0-24a6-461c-9ef1-86c5a6f33b83.jpg?1562943045"

    signal clickedOnCard(int state);

    width: parent.width
    height: card_size_y
    clip: true

    color: card_color

    Text
    {
        text: cardname
        clip: true
    }

    MouseArea
    {
        acceptedButtons: Qt.LeftButton
        width: card_size_x;

        anchors.fill: parent

        onClicked:
        {
            if(position==pos_op_lib)
            {
                position = pos_op_hand;
            }

            else if(position==pos_op_grave)
            {
                position = pos_op_hand;
            }
            else if(position==pos_op_removed)
            {
                position = pos_op_hand;
            }


            //position = position == 1 ? 2 : 1;
            parent.clickedOnCard(0); //selection state for indicator if card was clicked on
        }
    }

    MouseArea
    {
        acceptedButtons: Qt.RightButton
        width: card_size_x;
        z:2

        anchors.fill: parent

        onClicked:
        {
            if(position==pos_op_lib)
            {
                position = pos_op_field;
            }

            else if(position==pos_op_grave)
            {
                position = pos_op_field;
            }
            else if(position==pos_op_removed)
            {
                position = pos_op_field;
            }

            parent.clickedOnCard(0); //selection state for indicator if card was clicked on
        }
    }

    MouseArea
    {
        acceptedButtons: Qt.MiddleButton
        width: card_size_x;
        z:3

        anchors.fill: parent

        onClicked:
        {
            if(position==pos_op_lib)
            {
                position = pos_op_field;
            }

            else if(position==pos_op_grave)
            {
                position = pos_op_removed;
            }
            else if(position==pos_op_removed)
            {
                position = pos_op_grave;
            }

            parent.clickedOnCard(0); //selection state for indicator if card was clicked on
        }
    }

}
