#include "gamestate.h"

Gamestate::Gamestate(QObject *parent, QString _filename) : QObject(parent)
{
    /*
    player_hand.push_back(Card("Birds of Paradise","Alpha","Tap for any mana",Card::POS_PHAND));
    player_hand.push_back(Card("Baron Sengir","Alpha","Get stronger for each defeated enemy",Card::POS_PHAND));
    player_hand.push_back(Card("Shock","Alpha","Doe two damage",Card::POS_PHAND));

    player_field.push_back(Card("Fireball","Alpha","Do X damage",Card::POS_PFIELD));

    player_lib.push_back(Card("Serra Angel","Homelands","Flying. Vigilance.",Card::POS_PLIB));
    player_lib.push_back(Card("Serra's Embrace","Homelands","Flying. Vigilance.",Card::POS_PLIB));
    player_lib.push_back(Card("Birds of Paradise","Alpha","Tap for any mana",Card::POS_PLIB));
    player_lib.push_back(Card("Baron Sengir","Alpha","Get stronger for each defeated enemy",Card::POS_PLIB));
    player_lib.push_back(Card("Shock","Alpha","Doe two damage",Card::POS_PLIB));


    player_grave.push_back(Card("Shock","Alpha","Doe two damage",Card::POS_PGRAVE));

    player_hand_model = new QStandardItemModel(this);


    for(int i = 0; i < player_hand.size();i++)
    {
        addCard(player_hand[i]);
    }

    for (int i = 0; i < player_hand_model->rowCount(); ++i)
    {
        QString output;

        for (int a = 0; a < 3; ++a)
        {
            output+= player_hand_model->item(i,a)->text() + " | ";
        }

        //qDebug() << output;
    }

    dataList.append("Item 1");
    dataList.append("Item 2");
    dataList.append("Item 3");
    dataList.append("Item 4");
    */

    loadPlayerDeck(_filename);
	std::srand(std::time(nullptr));

	loadEnemyDeck(_filename);

    //player_tokens.push_back("10/10 Red Creature Token");
    //player_tokens.push_back("12/12 Green Creature Token");

    //qDebug() << player_hand_model->roleNames();
}

void Gamestate::addCard(const Card& _card)
{
    if(_card.name.isEmpty())
    {
        qDebug() << "empty card "  << _card;
        return;
    }

    //QStandardItem* item = ;




    QList<QStandardItem*> list;

    list.append(new QStandardItem(_card.name));
    list.append(new QStandardItem(_card.edition));
    list.append(new QStandardItem(_card.description));

    player_hand_model->appendRow(list);

    list.clear();


    /*
    const int newRow= player_hand_model->rowCount();
    const Card newCard(_card);
    player_hand_model->insertRow(newRow);
    //player_hand_model->setData(player_hand_model->index(newRow,0),QVariant::fromValue(newCard),Qt::EditRole);
    player_hand_model->setData(player_hand_model->index(newRow,0),QString(_card.getName()),Qt::EditRole);
    */
}

QVector<Card> &Gamestate::getVectorFromId(int _id)
{
    switch(_id)
    {
        case POSITION_PHAND: return player_hand; break;
        case POSITION_PFIELD: return player_field; break;
        case POSITION_PLIB: return player_lib; break;
        case POSITION_PGRAVE: return player_grave; break;
        case POSITION_PREMOVED: return player_exile; break;
		case POSITION_OFIELD: return opponent_field; break;
		case POSITION_OGRAVE: return opponent_grave; break;
		case POSITION_OLIB: return opponent_lib; break;
		case POSITION_OHAND: return opponent_hand; break;
		case POSITION_OREMOVED: return opponent_exile; break;

        default: qDebug() << "Warning  DEFAULT POSITION_PGRAVE: getVectorFromId" << _id; return player_grave; break;
    }
}

void Gamestate::loadPlayerDeck(const QString &_name)
{
    QFile file(_name);

    if (!file.open(QIODevice::ReadOnly | QIODevice::Text))
    {
        qDebug() << _name << " deck does not EXIST!";
        return;
    }

    while (!file.atEnd())
    {
        QByteArray line = file.readLine();
        int quantity = QByteArray::fromBase64(line).toInt();

        line = file.readLine();
        QString name = QByteArray::fromBase64(line);

        line = file.readLine();
        QString cost = QByteArray::fromBase64(line);

        line = file.readLine();
        QString type = QByteArray::fromBase64(line);

        line = file.readLine();
        QString color = QByteArray::fromBase64(line);

        line = file.readLine();
        QString power = QByteArray::fromBase64(line);

        line = file.readLine();
        QString life = QByteArray::fromBase64(line);

        line = file.readLine();
        QString rarity = QByteArray::fromBase64(line);

        line = file.readLine();
        QString editon = QByteArray::fromBase64(line);

        line = file.readLine();
        QString desc = QByteArray::fromBase64(line);

        line = file.readLine();
        QString flavor = QByteArray::fromBase64(line);


        for(int i = 0; i < quantity; i++)
        {
			player_lib.push_back(Card(name,editon,desc, type, cost, Card::POS_PLIB));
            connect(&(player_lib[i]),&Card::cardChanged,this,&Gamestate::isReady);

			//opponent_field.push_back(Card(name,editon,desc, type, Card::POS_OFIELD));
			//connect(&(opponent_field.last()),&Card::cardChanged,this,&Gamestate::isReady);

        }
    }

    QEventLoop loop;
    connect(this, SIGNAL(playerDeckReady()), &loop, SLOT(quit()));
    QTimer::singleShot(200, this, SLOT(isReady()));
    QTimer::singleShot(1000, this, SLOT(isReady()));
    loop.exec();


    shufflePlayerLib();
}

void Gamestate::loadEnemyDeck(const QString &_name)
{
	QStringList pathlist = _name.split("/");
	pathlist.removeLast();
	QString path = pathlist.join("/");
	path += "/aigobo.deck";

	qDebug() << path;

	QFile file(path);


	if (!file.open(QIODevice::ReadOnly | QIODevice::Text))
	{
		qDebug() << _name << " deck does not EXIST!";
		return;
	}

	while (!file.atEnd())
	{
		QByteArray line = file.readLine();
		int quantity = QByteArray::fromBase64(line).toInt();

		line = file.readLine();
		QString name = QByteArray::fromBase64(line);

		line = file.readLine();
		QString cost = QByteArray::fromBase64(line);

		line = file.readLine();
		QString type = QByteArray::fromBase64(line);

		line = file.readLine();
		QString color = QByteArray::fromBase64(line);

		line = file.readLine();
		QString power = QByteArray::fromBase64(line);

		line = file.readLine();
		QString life = QByteArray::fromBase64(line);

		line = file.readLine();
		QString rarity = QByteArray::fromBase64(line);

		line = file.readLine();
		QString editon = QByteArray::fromBase64(line);

		line = file.readLine();
		QString desc = QByteArray::fromBase64(line);

		line = file.readLine();
		QString flavor = QByteArray::fromBase64(line);

		//qDebug() << name << ": " << cost << " - " << Card::costToInt(cost);


		for(int i = 0; i < quantity; i++)
		{
			opponent_lib.push_back(Card(name,editon,desc, type, cost, Card::POS_OLIB));
			connect(&(opponent_lib[i]),&Card::cardChanged,this,&Gamestate::isReady);
		}
	}

	QEventLoop loop;
	connect(this, SIGNAL(playerDeckReady()), &loop, SLOT(quit()));
	QTimer::singleShot(200, this, SLOT(isReady()));
	QTimer::singleShot(1000, this, SLOT(isReady()));
	loop.exec();

	shuffleEnemyLib();
	shuffleEnemyLib();
	//shufflePlayerLib();
}

void Gamestate::loopOverCardsAndPutThemInTheVectorAccordingToItsPosition(int _source)
{
    /*
    QVector<Card> & source = getVectorFromId(_source);


    for(int i = 0; i < source.size(); i++)
    {
        if(source[i].position != _source)
        {

        }
        else
        {

        }
    }
    */
	qDebug() << "loopOverCardsAndPutThemInTheVectorAccordingToItsPosition: Not tested because removing an object from a vector decreases the vector and invalidates the index, dont use this function " + _source;
}

QString Gamestate::positionEnumToString(int _enum)
{

	switch (_enum)
	{
		case POSITION_PFIELD: return "Battlefield";
		case POSITION_PGRAVE: return  "Graveyard";
		case POSITION_PLIB: return "Library";
		case POSITION_PHAND: return "Hand";
		case POSITION_PREMOVED: return "Exile";

		case POSITION_OFIELD: return "OP Battlefield";
		case POSITION_OGRAVE: return  "OP Graveyard";
		case POSITION_OLIB: return "OP Library";
		case POSITION_OHAND: return "OP Hand";
		case POSITION_OREMOVED: return "OP Exile";

		default: return "positionEnumToString Unknown";
	}
}

void Gamestate::setChatText(const QString &_text)
{
	this->chat_text += "\n" + _text;
	qDebug() << "Set Chat Text: " + _text;
	emit chatTextChanged(this->chat_text);
}

void Gamestate::tokenPlayerChanged(int index, const QString text)
{
    player_tokens[index] = text;
    //qDebug() << "player_tokens["<<index<< "]" << player_tokens[index];
}

void Gamestate::createPlayerToken()
{
    player_tokens.push_back("Text");
    emit tokensChanged();
}

void Gamestate::deletePlayerToken(const QString &text)
{
    for(int i = 0; i < player_tokens.size();i++)
    {
        if(player_tokens.at(i) == text )
        {
            player_tokens.removeAt(i);
            break;
        }
    }
    emit tokensChanged();
}

bool Gamestate::isReady()
{
    bool ready = true;

    for(int i = 0; i < player_lib.size();i++)
    {
        ready = ready && player_lib[i].download_complete;
    }

    if(ready)
    {
        emit playerDeckReady();
    }



    return ready;
}

void Gamestate::moveCardPosition(int _source, int _target, int _id)
{

	//qDebug() << "In moveCardPosition s t i" <<  _source << _target << _id;

    QVector<Card> & source = getVectorFromId(_source);
    QVector<Card> & target = getVectorFromId(_target);

    int index = -1;
    for(int i = 0; i < source.size();i++)
    {
        if(source[i].id == _id)
        {
            index = i;
            break;
        }
    }

    if(index >= 0)
    {
		//qDebug() << "In moveCardPosition s t i" <<  positionEnumToString(_source) << positionEnumToString(_target) << source[index].name;

        //qDebug() << "index: " << index << " ||| " << source.at(index);

		const QString cardname = source[index].name;

        if(_target == POSITION_PLIB || _target == POSITION_PGRAVE || _target == POSITION_PREMOVED || _target == POSITION_OLIB || _target == POSITION_OGRAVE || _target == POSITION_OREMOVED)
        {
			Card tempcard = source.at(index);
			tempcard.position=_target;

			target.push_front(tempcard);
            source.removeAt(index);
        }
        else
        {
			Card tempcard = source.at(index);
			tempcard.position=_target;

			target.push_back(tempcard);
            source.removeAt(index);
        }

		emit gameStateChangedPreSignal(_source);
        emit gameStateChangedPreSignal(_target);
		emit chatInformation(QVariant(positionEnumToString(_source) + "➜" + positionEnumToString(_target) + ": " + cardname));
    }
    else
    {
        qDebug() << "ERROR index not found: " << index;
    }




    //loopOverCardsAndPutThemInTheVectorAccordingToItsPosition(_source);

}

void Gamestate::shufflePlayerLib()
{
    if(player_lib.size() < 1)
    {
        qDebug() << "WARNING player_lib.size() < 1";
        return;
    }

    std::srand(std::time(nullptr));

    for(int i = 0; i < 1000; i++)
    {

        int value1 = std::rand() % player_lib.size();
        int value2 = std::rand() % player_lib.size();

        if(value1 != value2)
        {
            Card temp(player_lib[value1], false);

            player_lib[value1] = player_lib[value2];
            player_lib[value2] = temp;
        }
    }

    //std::random_shuffle(player_lib.begin(), player_lib.end());
    //qDebug() << "After: " << player_lib;
    emit gameStateChangedPreSignal(POSITION_PLIB);

}

void Gamestate::shuffleEnemyLib()
{
    if(opponent_lib.size() < 1)
    {
        qDebug() << "WARNING opponent_lib.size() < 1";
        return;
    }

	for(int i = 0; i < 2000; i++)
    {

        int value1 = std::rand() % opponent_lib.size();
        int value2 = std::rand() % opponent_lib.size();

        if(value1 != value2)
        {
            Card temp(opponent_lib[value1], false);

            opponent_lib[value1] = opponent_lib[value2];
            opponent_lib[value2] = temp;
        }
    }

    //std::random_shuffle(player_lib.begin(), player_lib.end());
    emit gameStateChangedPreSignal(POSITION_OLIB);
}

void Gamestate::drawCardPlayer()
{
    if(player_lib.size() > 0)
    {
        player_lib.front().setPosition(POSITION_PHAND);
        player_hand.push_back(player_lib.front());
		this->lastCardDrawn = player_lib.first().name;
        player_lib.removeFirst();
        emit gameStateChangedPreSignal(POSITION_PLIB);
		emit chatInformation("Drawn: " + lastCardDrawn);
    }

    else
    {
        qDebug() << "Player Lib is empty, can not draw card.";
    }

}

void Gamestate::setPositionVariableAccordingToContainer()
{
    for(int i = 0; i < player_hand.size(); i++)
    {
        player_hand[i].setPosition(POSITION_PHAND);
    }

    for(int i = 0; i < player_lib.size(); i++)
    {
        player_lib[i].setPosition(POSITION_PLIB);
    }

    for(int i = 0; i < player_grave.size(); i++)
    {
        player_grave[i].setPosition(POSITION_PGRAVE);
    }

    for(int i = 0; i < player_field.size(); i++)
    {
        player_field[i].setPosition(POSITION_PFIELD);
    }

    for(int i = 0; i < player_exile.size(); i++)
    {
        player_exile[i].setPosition(POSITION_PREMOVED);
    }
}

void Gamestate::handleGameStateChangedPreSignal(int i)
{
    setPositionVariableAccordingToContainer();
    emit gameStateChanged(i);
}

void Gamestate::sortPlayerDeck()
{
	qSort(player_lib);
	emit gameStateChangedPreSignal(POSITION_PLIB);
}

//void Gamestate::sortBattleField();
void Gamestate::sortBattleField(int i)
{
	i++;
	std::sort(player_field.begin(), player_field.end(), [](const Card& first, const Card& second){ return first.name[0] <  second.name[0];} );
	emit(sortedBattlefield());
}

Gamestate::~Gamestate()
{
    //delete player_hand_model;
}

