#ifndef LIFE_H
#define LIFE_H

#include <QObject>

class Life : public QObject
{
    Q_OBJECT

    Q_PROPERTY(int player_life READ getPlayerLife WRITE setPlayerLife NOTIFY playerLifeChanged)
    Q_PROPERTY(int opponent_life READ getOpponentLife WRITE setOpponentLife NOTIFY opponentLifeChanged)
public:
    Life();
	const int player_start_life = 40;
	const int opponent_start_life = 40;
    int player_life = player_start_life;
    int opponent_life = opponent_start_life;

    inline int getPlayerLife() const
    {
        return player_life;
    }
    inline void setPlayerLife(int _life)
    {
        player_life = _life;
    }

    inline int getOpponentLife() const
    {
        return opponent_life;
    }
    inline void setOpponentLife(int _life)
    {
        opponent_life = _life;
    }

signals:
    void playerLifeChanged();
    void opponentLifeChanged();



};

#endif // LIFE_H
