#ifndef WEBAPI_H
#define WEBAPI_H

#include <QNetworkAccessManager>
#include <QNetworkRequest>
#include <QNetworkReply>
#include <QUrl>
#include <QMap>
#include <QPair>
#include <QJsonDocument>
#include <QJsonObject>
#include <QJsonArray>
#include <QDebug>
#include <QFile>

class Webapi : public QObject
{
    Q_OBJECT

public:
    Webapi();
    void getUrl(const QString& _name);
    QNetworkAccessManager *manager;
    QMap<QUrl, QPair<QString*,QString*> > lookup;

    QMap<QUrl,QString> urlToName;
    QMap<QString,QPair<QString, QString> > nameToImages;


public slots:
    void cardDownloadFinishedFromCache(const QString& _filename, const QString& _name);
    void cardDownloadFinished(QNetworkReply* reply);

signals:
    void downloadDone(const QString, const QString, const QString);
};

#endif // WEBAPI_H
